;Race v1.2a Source Code (C)2002 Erik Bergstrm
	.nolist
	#include "ion.inc"
	#define gametype	saferam1
	#define counter		saferam1+1
	#define pos		saferam1+2
	#define temp		saferam1+3
	#define score		saferam1+4
	.list
#ifdef TI83P
	.org    progstart-2
	.db $BB,$6D
#else
        .org    progstart
#endif
        ret				
        jr      nc,begin
        .db     "Race 1.2 By Erik Bergstrom",0
begin:
init:
	sbc hl,hl
	ld (score),hl
	bcall(_clrlcdfull)
	bcall(_homeup)
	set textInverse, (iy+textflags)
	ld hl,intro_text
	bcall(_puts)
	ld hl,256*1+3
	ld (currow),hl
	res textInverse, (iy+textflags)
	ld hl,t_gam1
	bcall(_puts)
	ld hl,1*256+4
	ld (CURROW),hl
	ld hl,t_gam2
	bcall(_puts)
	xor a
	ld (temp),a
	ld hl,7
	ld (CURROW),hl
	ld hl,hscorestr
	bcall(_puts)
	ld hl,(high)
	bcall(_disphl)

me_up:
	ld hl,4
	ld (CURROW),hl
	ld a,$20
	bcall(_putc)
	ld hl,3
	ld (CURROW),hl
	ld a,$DF
	bcall(_putc)	
mu_loop:
	ld a,$ff
	out (1),a
	ld a,$bf
	out (1),a 			
	in a,(1) 
	cp 223
	jr z,start_g1
	ld a,$ff
	out (1),a
	ld a,$fe
	out (1),a 			
	in a,(1)
	cp 254
	jr z,me_down
	jr mu_loop
me_down:
	ld hl,4
	ld (CURROW),hl
	ld a,$DF
	bcall(_putc)
	ld hl,3
	ld (CURROW),hl
	ld a,$20
	bcall(_putc)	
md_loop:
	ld a,$ff
	out (1),a
	ld a,$bf
	out (1),a 			
	in a,(1) 
	cp 223
	jp z,start_g2
	ld a,$ff
	out (1),a
	ld a,$fe
	out (1),a 			
	in a,(1)
	cp 247
	jr z,me_up
	jr md_loop

start_g1:
	xor a
	ld (gametype),a
	jr start
start_g2:
	ld a,1
	ld (gametype),a
;////////////////////////
;// The Main Game Loop //
;////////////////////////
start:
	bcall(_clrlcdfull)
	xor a
	ld (counter),a
	ld a,38
	ld (pos),a
   	call titleRoad
   	call ionFastCopy
	call d_sprite
	call ionFastCopy 
	call startloop
	call d_sprite
loop:
	ld a,(gametype)
	cp 0
	jr z,loopg1		; if gametype = 0 then jump to loopg1
	call Scroll_Down
	call addhole
	jr loop2
loopg1:
	call dbackg
loop2:
	ld a,0ffh 			;resets the keypad.
	out (1),a			;'Required syntax' :)
	ld a,$fe 			;Enable group 1.
	out (1),a 			
	in a,(1) 
	cp 253
	call z,right
	cp 251
	call z,left
	ld a,0ffh 			;resets the keypad.
	out (1),a			;'Required syntax' :)
	ld a,$fd
	out (1),a 			
	in a,(1) 
	cp 191
	jp z,quit
b_loop:
	call d_sprite	
	call ionFastCopy
	call d_sprite
	call det_hit
	ld a,(temp)
	dec a
	ret z
	call add_score
	jr loop

add_score:			;add 1 point to score :)
	ld hl,score
	ld a,(hl)
	inc a
	cp 255
	jr z,add_score2
	ld (hl),a
	ret
add_score2:
	ld hl,score
	ld (hl),0
	inc hl
	ld a,(hl)
	inc a
	cp 255
	jr z,add_score3
	ld (hl),a
	ret
add_score3:
	ld hl,score
	inc hl
	ld (hl),0
	inc hl
	ld a,(hl)
	inc a
	cp 255
	jr z,add_score3
	ld (hl),a
	ret
det_hit:			;hit detection (GR OM MED ION RUTINERNA :)
	ld a,(96/2)+5
	ld b,a
	ld c,10
	ld d,3
	bcall(_ipoint)
	jp nz,gameover
	ld a,(96/2)+4
	ld b,a
	ld c,10
	ld d,3
	add a,6
	ld b,a
	ld c,10
	ld d,3
	bcall(_ipoint)
	jp nz,gameover
	ret
d_sprite:
	ld ix,s_car
	ld a,(96/2)+4
	ld l,62-8
	ld b,8
	call ionPutSprite
	ret

dbackg:
	call scroll_down
	call dest_line
	ld b,4
	call ionRandom
	dec a
	jr z,l_right2
	dec a
	jr z,l_left2
	dec a
	jr z,l_right
l_left:
	ld a,(pos)
	dec a
	jr z,dbackg2
	ld (pos),a
	jr dbackg2
l_left2:
	ld a,(pos)
	dec a
	jr z,dbackg2
	dec a
	jr z,dbackg2
	ld (pos),a
	jr dbackg2
l_right2:
	ld a,(pos)
	cp 56
	jr z,dbackg2
	cp 55
	jr z,dbackg2
	inc a
	inc a
	ld (pos),a
	jr dbackg2
l_right:
	ld a,(pos)
	cp 56
	jr z,dbackg2
	inc a
	ld (pos),a
dbackg2:
draw_line:
	ld l,0
	ld b,1
	ld c,4
	ld a,(pos)
	ld ix,wall
	call ionLargeSprite
	ret
dest_line:
	ld hl,plotsscreen
	ld a,255
	ld b,12
dest_loop:
	ld (hl),a
	inc hl
	djnz dest_loop
	ret


addhole:
	ld hl, plotsscreen
	xor a
	ld b,12
addhole_2:
	ld (hl),a
	inc hl
	djnz addhole_2
	ld a,(counter)
	cp 9
	jr z,addhole2
	inc a
	ld (counter),a
	ret
addhole2:
	xor a
	ld (counter),a
	ld b,86
	call ionRandom
	ld b,8
	ld l,1
	ld ix,s_hole
	jp ionPutSprite
;*************
;*Other Stuff*
;*************
startloop:
	ld a,0ffh 			;resets the keypad.
	out (1),a			;'Required syntax' :)
	ld a,$fe
	out (1),a 			
	in a,(1) 
	cp 247
	ret z
	jr startloop

titleRoad:				;draws the title pic/road 
	ld hl,road
	ld b,64
	ld de,plotsscreen
titleRoad2:
	push bc
	ld hl,road
	ld bc,12
	push de
	ldir
	pop de
	ex de,hl
	ld de,12
	add hl,de
	ex de,hl
	pop bc
	djnz titleRoad2
	ret
Road:
	.db $ff,$ff,$ff,$ff,$ff,$00,$00,$00,$00,$ff,$ff,$ff

Scroll_Down:		;The scroll down routin
	ld hl, Plotsscreen+755
	ld de, Plotsscreen+767
	ld bc, 756
	lddr
	ret
gameover:
	ld hl,256*4+2
	ld (currow),hl
	ld hl,txt_gover
	bcall(_puts)
	ld hl,5
	ld (currow),hl
	ld      hl,scorestr             ;
	bcall(_puts)                    ; write "Score: "
	ld      hl,(score)              ;
	bcall(_disphl)                  ;
	ld      hl,(score)              ;
	ld      de,(high)               ;
	bcall(_cphlde)                  ;
	jr      c,gameover2             ;
	ld      (high),hl               ;
	bcall(_newline)                 ;
	ld      hl,highstr              ;
	bcall(_puts)                    ; write "New High!"
gameover2:
	ld a,0ffh 			;resets the keypad.
	out (1),a			;'Required syntax' :)
	ld a,$fd
	out (1),a 			
	in a,(1)
	cp 191
	jr z,quit
	cp 254
	jr z,quit 
	jr gameover2


Right:
Scroll_Right:
        ld de, 12
        ld hl, Plotsscreen-1
        ld b, 64
Right_Carry:
        push hl
        add hl,de
        ld a, 1
        and (hl)
        NEG
        pop hl
        ld c, b
        ld b, 12
Right_Loop:
        inc hl
        RR (hl)
        djnz Right_Loop
        ld b, c
        djnz Right_Carry
        ret
Left:
Scroll_Left:
        ld hl, Plotsscreen-1
        ld de, 12
        ld b, 64
Left_Carry:
        inc hl
        ld a, (hl)
        and %10000000
        add hl, de
        sub %10000000
        CCF
        ld c, b
        ld b, 12
Left_Loop:
        dec hl
        RL (hl)
        djnz Left_Loop
        ld b, c
        dec hl
        add hl, de
        djnz Left_Carry
        ret

quit:	
	ld a,1
	ld (temp),a
	ret

high:   
	.dw 0		;highscore save
wall:
	.db $FF, $FF, $FF, $FF		;road sprite
txt_gover:
	.db "Game Over",0
hscorestr:
	.db "High: ",0
intro_text:
	.db "   Race v1.2    ",0
scorestr:
	.db "Score:",0
highstr:
	.db "New High!",0
t_gam1:
	.db "Game type A",0
t_gam2:
	.db "Game type B",0

s_hole:
	.db $3C,$7E,$FF,$FF,$FF,$FF,$7E
s_car:				
	.db $3C,$42,$5A,$24,$24,$5A,$66,$3C		;sprite data for carintro_text:
.end

